
#Requierd variables -------------------------------
var_path="./tmp/var.txt"
hba_path=""
conf_path=""
r_path=./tmp/r
e_path=./tmp/e
#--------------------------------------------------

#Set variables ------------------------------------

hba_path="$( bash <<EOF
grep "pg_hba.conf" $var_path
EOF
)"

conf_path="$( bash <<EOF
grep "postgresql.conf" $var_path
EOF
)"

data_path="$( bash <<EOF
grep "var/lib" $var_path
EOF
)"

echo "-------- [Hardening Options] --------"
echo "  [1] Immunization Runtime Environment"
echo "  [2] Secure Connection to The Database"
echo "  [3] Authentication"
echo "  [4] Audithing"
read -r -p "Select the desired option? [1/2/3/4/5] " response

if [[ "$response" -eq 1 ]]; then
###########################################################################################################
#-----------------------Section[1]: Immunization Runtime Environment   ------------------------------------
###########################################################################################################

#-----------------------Section[1-1]:Configuration File Access Rights  ------------------------------------
dif11=$(diff $r_path/r1-1 $e_path/r1-1)
if [[ -n $dif11 ]] ; then
read -r -p "Change permission of configuration file? [y/N] " response
if [[ $response =~ ^([yY][eE][sS]|[yY])$ ]] ; then
chown -R root $conf_path
chgrp -R root $conf_path
chmod -R 644 $conf_path
fi
fi

#-----------------------Section[1-2]:Data storage folder Access Rights ------------------------------------
dif11=$(diff $r_path/r1-2 $e_path/r1-2)
if [[ -n $dif11 ]] ; then
read -r -p "Change permission of data storage folder? [y/N] " response
if [[ $response =~ ^([yY][eE][sS]|[yY])$ ]] ; then
chown postgres $data_path
chgrp postgres $data_path
chmod 700 $data_path
fi
fi

#-----------------------Section[1-3]:Event log file Access Rights      ------------------------------------
dif11=$(diff $r_path/r1-3 $e_path/r1-3)
if [[ -n $dif11 ]] ; then
read -r -p "Change permission of event log file? [y/N] " response
if [[ $response =~ ^([yY][eE][sS]|[yY])$ ]] ; then
chown postgres /var/log/postgresql
chgrp postgres /var/log/postgresql
chmod 640 /var/log/postgresql
fi
fi

elif [[ "$response" -eq 2 ]]; then

###########################################################################################################
#-----------------------Section[2]: Secure Connection to The Database -------------------------------------
###########################################################################################################

#-----------------------Section[2-1]:Listen Addresses Parameter -------------------------------------------
dif21=$(diff $r_path/r2-1 $e_path/r2-1)
if [[ -n $dif21 ]] ; then
read -r -p "Change listen_addresses to local host? [y/N] " response
if [[ $response =~ ^([yY][eE][sS]|[yY])$ ]] ; then
sed -i "s/\(.*\)listen_addresses = .*.# \(.*\)/listen_addresses = '"'localhost'"'          # \2/" $conf_path
fi
fi

#-----------------------Section[2-2]:Port Parameter -------------------------------------------------------
dif22=$(diff $r_path/r2-2 $e_path/r2-2)
if [[ -n $dif22 ]] ; then
read -r -p "Change port number? [y/N] " response
if [[ $response =~ ^([yY][eE][sS]|[yY])$ ]] ; then
read -r -p "new port: " port
sed -i "s/\(.*\)port = .*.#\(.*\)/port = ${port}          # \2/" $conf_path
fi
fi

#-----------------------Section[2-3]:Max Connections Parameter --------------------------------------------
dif23=$(diff $r_path/r2-3 $e_path/r2-3)
if [[ -n $dif23 ]] ; then
read -r -p "Change max_connection? [y/N] " response
if [[ $response =~ ^([yY][eE][sS]|[yY])$ ]] ; then
read -r -p "max_connection: " maxc
sed -i "s/\(.*\)max_connections = .*.#\(.*\)/max_connections = ${maxc}            #\2/" $conf_path
fi
fi

#-----------------------Section[2-4]:Unix Socket Permission Parameter -------------------------------------
f24_1=$(head -n 2 $r_path/r2-4)
f24_2=$(head -n 2 $e_path/r2-4)
if [[ $f24_1 != $f24_2 ]] ; then
read -r -p "Change unix_socket_permissions? [y/N] " response
if [[ $response =~ ^([yY][eE][sS]|[yY])$ ]]
then
sed -i "s/\(.*\)unix_socket_permissions = *.*#\(.*\)/unix_socket_permissions = 0700            #\2/"  $conf_path
fi
fi

#-----------------------Section[2-5]:Authentication Timeout Parameter -------------------------------------
dif25=$(diff $r_path/r2-5 $e_path/r2-5)
if [[ -n $dif25 ]] ; then
read -r -p "Change authentication_timeout? [y/N] " response
if [[ $response =~ ^([yY][eE][sS]|[yY])$ ]]
then
sed -i "s/\(.*\)authentication_timeout = .*.#\(.*\)/authentication_timeout = 1min           #\2/" $conf_path
fi
fi

#-----------------------Section[2-6]:Password Encryption Parameter ----------------------------------------
dif26=$(diff $r_path/r2-6 $e_path/r2-6)
if [[ -n $dif26 ]] ; then
read -r -p "Enable password_encryption? [y/N] " response
if [[ $response =~ ^([yY][eE][sS]|[yY])$ ]]
then
sed -i "s/\(.*\)password_encryption = *.*#\(.*\)/password_encryption = md5            #\2/"  $conf_path
fi
fi

#-----------------------Section[2-7]:SSL Parameter --------------------------------------------------------
dif27=$(diff $r_path/r2-7 $e_path/r2-7)
if [[ -n $dif27 ]] ; then
read -r -p "Enable SSL_connections? [y/N] " response
if [[ $response =~ ^([yY][eE][sS]|[yY])$ ]]
then
sed -i "s/\(.*\)ssl = .*.\(.*\)/ssl = on             \1/" $conf_path
fi
fi

elif [[ "$response" -eq 3 ]]; then

###########################################################################################################
#-----------------------Section[3]: Authentication --------------------------------------------------------
###########################################################################################################

#-----------------------Section[3-1]:Secure Authentication (Convert Trust to md5) -------------------------
i=1
dif31=$(diff $r_path/r3-1 $e_path/r3-1)
if [[ -n $dif31 ]] ; then
read -r -p "Change trust connections to md5? [y/N] " response
if [[ $response =~ ^([yY][eE][sS]|[yY])$ ]]
then

while IFS=$'\t' read -r f1 f2
do

if [ "$f1" != "" ]; then
if [ $i -gt 1 ]; then
  rd1=$( echo "$f1" | sed -e 's/[\/&]/\\&/g')
  rd2=$( echo "$f2" | sed -e 's/[\/&]/\\&/g')
  sed -i "s/${rd1}/${rd2}/" $hba_path
fi
  i=$(expr $i + 1)
fi
  
done < <(paste $r_path/r3-1 $e_path/r3-1)
fi
fi

#-----------------------Section[3-2]:Secure Remote Connection for Superuser -------------------------------
j=1
s=""
y=""
dif32=$(diff $r_path/r3-2 $e_path/r3-2)
if [[ -n $dif32 ]] ; then
read -r -p "Change Secure Remote Connection for Superuser? [y/N] " response
if [[ $response =~ ^([yY][eE][sS]|[yY])$ ]]
then

while read -r -u 4 f3 && read -r -u 5 f4
do
s=$f4
if [ "$f3" != "" ]; then
y=$f3
if [ $j -gt 1 ]; then
  echo "f3-1: $f3"
  echo "f4-1: $f4"
  
  rd3=$( echo "$f3" | sed -e 's/[\/&]/\\&/g')
  rd4=$( echo "$f4" | sed -e 's/[\/&]/\\&/g')
  
  
  echo "Thanks."
  sed -i "s/${rd3}/${rd4}/" $hba_path
fi
  j=$(expr $j + 1)
fi

done 4<$r_path/r3-2 5<$e_path/r3-2

rd3=$( echo "$y" | sed -e 's/[\/&]/\\&/g')
rd4=$( echo "$s" | sed -e 's/[\/&]/\\&/g')

echo "Line 1: $rd3"
echo "Line 2: $rd4"

sed -i "/${rd3}/ a ${rd4}" $hba_path

fi
fi

#-----------------------Section[3-3]:Final Rule of Authentication -----------------------------------------
dif33=$(diff $r_path/r3-3 $e_path/r3-3)
if [[ -n $dif33 ]] ; then
read -r -p "Add Final Rule of Authentication? [y/N] " response
if [[ $response =~ ^([yY][eE][sS]|[yY])$ ]]
then

rd1=$( echo "host all all 0.0.0.0/0 md5" | sed -e 's/[\/&]/\\&/g')

if [[ $(grep "$rd1" $hba_path) ]] ; then
   echo "File rule already exist."
else
   sed -i -e "$ a $rd1" $hba_path
fi

fi
fi

elif [[ "$response" -eq 4 ]]; then

###########################################################################################################
#-----------------------Section[4]: Audithing -------------------------------------------------------------
###########################################################################################################

#-----------------------Section[4-1]:Logging Collector Parameter ------------------------------------------
dif41=$(diff $r_path/r4-1 $e_path/r4-1)
if [[ -n $dif41 ]] ; then
read -r -p "Enable Logging Collector Parameter? [y/N] " response
if [[ $response =~ ^([yY][eE][sS]|[yY])$ ]]
then
sed -i "s/\(.*\)logging_collector = *.*# \(.*\)/logging_collector = on		# \2/" $conf_path
fi
fi

#-----------------------Section[4-2]:Log Directory Parameter ----------------------------------------------
dif42=$(diff $r_path/r4-2 $e_path/r4-2)
if [[ -n $dif42 ]] ; then
read -r -p "Change Log Directory Parameter? [y/N] " response
if [[ $response =~ ^([yY][eE][sS]|[yY])$ ]]
then
sed -i "s/\(.*\)log_directory = '"'.*.'"'.*# \(.*\)/log_directory = '"'pg_log'"'	# \2/"  $conf_path
fi
fi

#-----------------------Section[4-3]:Log Connections Parameter --------------------------------------------
dif43=$(diff $r_path/r4-3 $e_path/r4-3)
if [[ -n $dif43 ]] ; then
read -r -p "Enable Log Connections Parameter? [y/N] " response
if [[ $response =~ ^([yY][eE][sS]|[yY])$ ]]
then
sed -i "s/\(.*\)log_connections = .*.\(.*\)/log_connections = on	\1/" $conf_path
fi
fi

#-----------------------Section[4-4]:Log Disconnections Parameter -----------------------------------------
dif44=$(diff $r_path/r4-4 $e_path/r4-4)
if [[ -n $dif44 ]] ; then
read -r -p "Enable Log Disconnections Parameter? [y/N] " response
if [[ $response =~ ^([yY][eE][sS]|[yY])$ ]]
then
sed -i "s/\(.*\)log_disconnections = .*.\(.*\)/log_disconnections = on		\1/"  $conf_path
fi
fi

#-----------------------Section[4-5]:Log Hostname Parameter -----------------------------------------------
dif45=$(diff $r_path/r4-5 $e_path/r4-5)
if [[ -n $dif45 ]] ; then
read -r -p "Enable Log Hostname Parameter? [y/N] " response
if [[ $response =~ ^([yY][eE][sS]|[yY])$ ]]
then
sed -i "s/\(.*\)log_hostname = .*.\(.*\)/log_hostname = on		\1/" $conf_path
fi
fi

fi



