#!/bin/bash

path=/etc/mysql


wmctrl > /dev/null
if [ $? -eq 1 ]; then
wmctrl -r :ACTIVE: -b add,fullscreen
printf "\033c"
else
echo "Please maximize terminal window"
printf "\033c"
fi


if [ -f /etc/init.d/mysql ]; then

echo ""
echo "###########################################################################################################"
echo "------------------------------------------------ [First Test] ---------------------------------------------"
echo ""

	read -r -p    "MySQL_user: "  u
	read -r -s -p "MySQL_password: "  p
	echo 
	export user=$u
	export password=$p
	mysql --user=$u --password=$p -e "use mysql;">/dev/null 2>&1 && var=1 || var=0
if [[ $var -eq 1 ]] ; then
	read -r -p "Do you want to test your MySQL? [y/N] " response
	if [[ $response =~ ^([yY][eE][sS]|[yY])$ ]] ; then
		if [ ! -f $path/my.cnf ]; then
		   	 echo "my.cnf not found!"
		else
			./script.sh
			sdiff -l r e | sed 's/diff.*/\n/' | sed '1s/^/          "MySQL RESULT"                                             "EXPECTED RESULT" /' > 				first_test_result
			echo "you can see the result in 'first_test_result' file."
		fi
	fi
	
echo ""
echo "------------------------------------------------ [First Test] ---------------------------------------------"
echo "###########################################################################################################"
echo ""


echo ""
echo "###########################################################################################################"
echo "------------------------------------------- [Repair Configuration] ----------------------------------------"
echo ""

	read -r -p "Do you want to repair your MySQL? [y/N] " response
	if [[ $response =~ ^([yY][eE][sS]|[yY])$ ]] ; then
		read -r -p "Change root username and password? [y/N] " response
		if [[ $response =~ ^([yY][eE][sS]|[yY])$ ]] ; then
			read -r -p "new-name: " name2
			read -r  -s -p "new-password: " pass2
			mysql --user=$user --password=$password -e "RENAME USER ${user}@localhost TO  '${name2}'@localhost;"
			echo rename ok!
			user=$name2
			mysql --user=$user --password=$password -e "SET PASSWORD FOR '${user}'@'localhost' = PASSWORD('${pass2}')";
			echo repass ok!
			password=$pass2
		fi
		if [ ! -f $path/my.cnf ]; then
		        echo "my.cnf not found!"
		else
			./repair-old.sh
		fi
	fi

echo ""
echo "------------------------------------------- [Repair Configuration] ----------------------------------------"
echo "###########################################################################################################"
echo ""


echo ""
echo "###########################################################################################################"
echo "------------------------------------------------ [Second Test] --------------------------------------------"
echo ""

	read -r -p "Do you want to test your MySQL again? [y/N] " response
	if [[ $response =~ ^([yY][eE][sS]|[yY])$ ]] ; then
		read -r -p "restart your mysqld? [y/N] " response1
		if [[ $response1 =~ ^([yY][eE][sS]|[yY])$ ]] ; then
			service mysql restart

			vv=$(ls -lh /var/log/mysql/* | grep - |awk '{print $9}')
			chown -R mysql $vv
			chgrp -R adm $vv
			chmod 640 $vv

		fi
		if [ ! -f $path/my.cnf ]; then
		   	echo "my.cnf not found!"
		else
		./script.sh
		sdiff -l r e | sed 's/diff.*/\n/' | sed '1s/^/          "MySQL RESULT"                                             "EXPECTED RESULT" /' > second_test_result
		echo "you can see the result in 'second_test_result' file."
		fi
	fi
	
echo ""
echo "------------------------------------------------ [Second Test] --------------------------------------------"
echo "###########################################################################################################"
echo ""	

fi
else
echo "MySQL is currently not installed!"
fi

wmctrl > /dev/null
if [ $? -eq 1 ]; then
wmctrl -r :ACTIVE: -b remove,fullscreen
printf "\033c"
fi

